Foreman - Bug #6205

Custom SSL client cert for smart proxy based auth doesn't split CN correctly
06/12/2014 08:18 PM - Anonymous

Status: Closed
Priority: Normal
Assignee: Ori Rabin
Category: Users, Roles and Permissions
Target version: 1.6.0
Difficulty: easy Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1108740 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/1678
Description

https://bugzilla.redhat.com/show_bug.cgi?id=1108740

in app/controllers/concerns/foreman/controller/smart_proxy_auth.rb

dn is evaluating with this format on RHEL 6:
/C=US/ST=North Carolina/O=FOREMAN/OU=PUPPET/CN=satellite1.montleon.intra

but on RHEL 7 it is coming up as:
CN=satellite2.montleon.intra, OU=PUPPET,O=FOREMAN,ST=North Carolina,C=US

SO on:
https://github.com/theforeman/foreman/blob/develop/app/controllers/concerns/foreman/controller/smart_proxy auth.rb#L44

this is causing $1 one from the match above to be:
"satellite2.montleon.intra, OU=PUPPET,O=FOREMAN,ST=North"

by changing request_hosts = [$1] to request_hosts = [$1.gsub(/,(\S+)/i, ")] it seems to work around the issue. I'm not sure if this is the
best approach to fixing it or if someone can foresee a better way.

Associated revisions

Revision 2821b5e2 - 08/15/2014 09:25 AM - Andrew N
fixes #6205 Changed regex to parse CNs from SSL DNs on separator chars

Revision add3bbdd - 08/27/2014 08:02 AM - Andrew N
fixes #6205 Changed regex to parse CNs from SSL DNs on separator chars

(cherry picked from commit 2821b5e250d2f311e2070c41879720f8745507cf)

History

#1 - 06/12/2014 09:32 PM - Dominic Cleal

- Category set to Users, Roles and Permissions

#2 - 06/12/2014 09:32 PM - Dominic Cleal
- Bugzilla link set to https://bugzilla.redhat.com/show_bug.cgi?id=1108740

#3 - 06/25/2014 06:52 AM - Dominic Cleal
- Subject changed from Need to set restrict_registered_puppetmasters=false in foreman settings under auth in order for puppet runs to succeed on

EL7 to Custom SSL client cert for smart proxy based auth doesn't split CN correctly

#4 - 07/14/2014 03:17 PM - Andrew N

I'm trying to get Foreman installed at a client site and have been running into the above bug, but for different reasons. If you generate the PKI certs
https://bugzilla.redhat.com/show_bug.cgi?id=1108740
https://github.com/theforeman/foreman/blob/develop/app/controllers/concerns/foreman/controller/smart_proxy_auth.rb#L44

on windows, it will use "/" as the separation character. In addition the default regex will not pull only the CN entry, but anything after the CN as well.
This was causing strange errors like the following:

/var/log/foreman/production.log:No smart proxy server found on ["foreman.linux.lab.local/emailAddress=user@exa
mple.com"] and is not in trusted_puppetmaster_hosts

The DN for the cert in question which was signed by a Windows CA is:

"/C=US/ST=NC/L=City/O=Example/OU=IT/CN=foreman.linux.lab.local/emailAddress=user@example.com"

if https://github.com/theforeman/foreman/blob/develop/app/controllers/concerns/foreman/controller/smart_proxy_auth.rb#L41 is changed to the string
below, the parse works for SSL certs which use "/" and "," as the separator.

dn =~ /CN=(["\s\/,]1+)/1

#5 - 07/16/2014 10:49 AM - Ohad Levy

- Assignee set to Ori Rabin

#6 - 07/17/2014 07:40 AM - Ori Rabin

Andrew, it looks like your solution is a good fix
would you like to send the pull request?

#7 - 08/11/2014 11:16 AM - Andrew N

Ori,

I'll see what | can do to put a pull together for it. Are there any appropriate pages | should read first?

#8 - 08/11/2014 11:30 AM - Andrew N

Ohad, Ori

I've almost got a pull request done, but I'm wondering if we might be going about this all wrong. | know with the openssl command line utilities it will
often display the CN entry with "," and "/" characters as separators using it's default mode. There is an option to display the CN using only ","

characters, | think the option option is an RFC related one, it's been a few weeks | don't exactly recall. Perhaps it would be best to first extract the CN
using the appropriate format, then parse on that.

#9 - 08/11/2014 11:39 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Target version setto 1.7.5

- Pull request https://github.com/theforeman/foreman/pull/1678 added
- Pull request deleted ()

#10 - 08/11/2014 11:39 AM - Andrew N
Pull request #1678 created.

#11 - 08/15/2014 09:43 AM - Dominic Cleal

- translation missing: en.field_release set to 10

#12 - 08/15/2014 11:02 AM - Andrew N
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 2821b5e250d2f311e2070c41879720{8745507cf.
